-- Sierpins.ex
-- Sierpinski Triangle Demo Program
-- Ported from a TI-83 program

without type_check

-- Include
include extra.e
include get.e
include graphics.e

-- Declare
constant POINTS = 100000, SCREEN = 1
integer color, key, locator
sequence point

clear_screen()
text_color(BRIGHT_WHITE)
puts(SCREEN, "Sierpinski Triangle Demo Program\nPorted from a TI-83 program\n\n")
text_color(WHITE)
puts(SCREEN, "Press CTRL+Q to quit or ENTER to run demo...")
while 1 do
    key = wait_key()
    if key = 13 then
        if graphics_mode(18) then
            puts(SCREEN, "\n\nError: Could not load 640 x 480, 16-colour pixel-graphics mode.\nPress any key to escape...")
            wait_any_key()
            clear_screen()
        else
            point = {0, 0}
            for n = 1 to POINTS do
                 locator = rand(3)
                 if locator = 1 then
                     color = BRIGHT_RED
                     point = point / 2
                 elsif locator = 2 then
                     color = BRIGHT_GREEN
                     point[1] = point[1] / 2 + 160
                     point[2] = (point[2] / 2 + 240)
                 else
                     color = BRIGHT_BLUE
                     point[1] = point[1] / 2 + 320
                     point[2] = point[2] / 2
                 end if
                 pixel(color, {point[1], 480 - point[2]})
            end for
            wait_any_key()
            def_graphics_mode()
        end if
        exit
    elsif key = 17 then
        clear_screen()
        exit
    end if
end while